#include "AlphaEngine/PBrush/CSG.h"
#include "AlphaEngine/Bsp/BspNode.h"

CPolygon* CSG::add(CPolygon* pA, CPolygon* pB)
{
	// return {all A outside B } + { all B outside A }
	
	// get copies of list a and b
	CPolygon* pRoot = 0;
	CPolygon* pListA = 0;
	CPolygon* pListB = 0;

	pRoot = pA;
	pListA = 0;
	while (pRoot != 0)
	{
		if (pListA)
			pListA->add(pRoot->clone());
		else
			pListA = pRoot->clone();

		pRoot = pRoot->pNext;
	}

	pRoot = pB;
	pListB = 0;
	while (pRoot != 0)
	{
		if (pListB)
			pListB->add(pRoot->clone());
		else
			pListB = pRoot->clone();

		pRoot = pRoot->pNext;
	}

	CPolygon* pRetPolygon = 0;

	CPolygon* curA = pListA;
	CPolygon* curB = pListB;
	
	CBspNode* pBspA = new CBspNode();
	CBspNode* pBspB = new CBspNode();
	
	pBspA->create(pA);
	pBspB->create(pB);

	while (curA != 0)
	{
		CPolygon* nextA = curA->pNext;
		curA->pNext = 0;

		if (pRetPolygon)
			pRetPolygon->add(pBspB->clip(curA, ALPHA_INFRONT));
		else
			pRetPolygon = pBspB->clip(curA, ALPHA_INFRONT);

		curA = nextA;
	}

	while (curB != 0)
	{
		CPolygon* nextB = curB->pNext;
		curB->pNext = 0;

		if (pRetPolygon)
			pRetPolygon->add(pBspA->clip(curB, ALPHA_INFRONT));
		else
			pRetPolygon = pBspA->clip(curB, ALPHA_INFRONT);

		curB = nextB;
	}

	delete pBspA;
	delete pBspB;

	return pRetPolygon;
}

CPolygon* CSG::subtract(CPolygon* pA, CPolygon* pB)
{
	// All B inside A FLIPPED and all A outside B
	// get copies of list a and b
	CPolygon* pRoot = 0;
	CPolygon* pListA = 0;
	CPolygon* pListB = 0;

	pRoot = pA;
	pListA = 0;
	while (pRoot != 0)
	{
		if (pListA)
			pListA->add(pRoot->clone());
		else
			pListA = pRoot->clone();

		pRoot = pRoot->pNext;
	}

	pRoot = pB;
	pListB = 0;
	while (pRoot != 0)
	{
		if (pListB)
			pListB->add(pRoot->clone());
		else
			pListB = pRoot->clone();

		pRoot = pRoot->pNext;
	}

	CPolygon* pRetPolygon = 0;

	CPolygon* curA = pListA;
	CPolygon* curB = pListB;
	
	CBspNode* pBspA = new CBspNode();
	CBspNode* pBspB = new CBspNode();
	
	pBspA->create(pA);
	pBspB->create(pB);

	while (curA != 0)
	{
		CPolygon* nextA = curA->pNext;
		curA->pNext = 0;

		if (pRetPolygon)
			pRetPolygon->add(pBspB->clip(curA, ALPHA_INFRONT));
		else
			pRetPolygon = pBspB->clip(curA, ALPHA_INFRONT);

		curA = nextA;
	}

	while (curB != 0)
	{
		CPolygon* nextB = curB->pNext;
		curB->pNext = 0;

		if (pRetPolygon)
		{
			CPolygon* pInsideA = 0;
			pInsideA = pBspA->clip(curB, ALPHA_BEHIND);
			
			// flip all polygon fragments
			CPolygon* pTemp = pInsideA;
			while (pTemp != 0)
			{
				pTemp->flip();
				pTemp = pTemp->pNext;
			}
			pRetPolygon->add(pInsideA);
		}
		else
		{
			pRetPolygon = pBspA->clip(curB, ALPHA_BEHIND);
			// flip all polygon fragments
			CPolygon* pTemp = pRetPolygon;
			while (pTemp != 0)
			{
				pTemp->flip();
				pTemp = pTemp->pNext;
			}
		}

		curB = nextB;
	}

	delete pBspA;
	delete pBspB;

	return pRetPolygon;
}

