// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"

#include "WorldEditor.h"
#include "EditorView.h"
#include "ControlBox.h"
#include "MainFrm.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_MOUSE, OnUpdateMousePos)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_MOUSE,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_initSplitters = false;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	CRect cr;
	GetClientRect(&cr);

	if (!m_mainSplitter.CreateStatic(this, 1, 2))
	{
		MessageBox("Error setting up splitter frames.", "Initialization Error!", MB_OK | MB_ICONERROR);
		return FALSE;
	}

	if (!m_mainSplitter.CreateView(0, 0, RUNTIME_CLASS(CEditorView), CSize(cr.Width() - INFOBAR_SIZE, cr.Height()), pContext))
	{
		MessageBox("Error setting up OpenGL", "Initialization Error!", MB_OK | MB_ICONERROR);
		return FALSE;
	}

	if (!m_mainSplitter.CreateView(0, 1, RUNTIME_CLASS(CControlBox), CSize(INFOBAR_SIZE, cr.Height()), pContext))
	{
		MessageBox("Error setting up the control panel view.", "Initialization Error!", MB_OK | MB_ICONERROR);
		return FALSE;
	}

	m_initSplitters = true;
	return TRUE;
}

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);
	CRect cr;

	if ( m_initSplitters && nType != SIZE_MINIMIZED )
	{
		m_mainSplitter.SetRowInfo( 0, cy, 0 );
		m_mainSplitter.SetColumnInfo( 0, cx - INFOBAR_SIZE, 0 );
		m_mainSplitter.SetColumnInfo( 1, INFOBAR_SIZE, 0 );
		m_mainSplitter.RecalcLayout();
	}	
}

void CMainFrame::OnUpdateMousePos(CCmdUI * pCmdUI)
{
	pCmdUI->Enable();
}

void CMainFrame::SetMousePosText(CString strText)
{
	int nIndex = m_wndStatusBar.CommandToIndex(ID_INDICATOR_MOUSE);
	m_wndStatusBar.SetPaneText(nIndex, strText);
	CWindowDC dc(&m_wndStatusBar);
	CSize sizeText = dc.GetTextExtent(strText);
	m_wndStatusBar.SetPaneInfo(nIndex, ID_INDICATOR_MOUSE, SBPS_NORMAL, sizeText.cx);
}

